#version 120

uniform sampler2D src_tex_unit0;
uniform vec2 src_tex_size1;
varying vec4 v_color;
varying vec2 texcoord;

void main() {
	float xp = texcoord.x;
	float yp = texcoord.y;
	float hx = xp * 0.5;
	float hy = yp * 0.5;
	float uy = hy + src_tex_size1.y;
	float ux = hx;
	float vx = hx + src_tex_size1.x;
	
	float y = texture2D(src_tex_unit0, vec2(xp, yp)).r;
	float u = texture2D(src_tex_unit0, vec2(ux,uy)).r - 0.5;
	float v = texture2D(src_tex_unit0, vec2(vx,uy)).r - 0.5;
	
	
	float r = y + 1.402 * v;
	float g = y - 0.344 * u - 0.714 * v;
	float b = y + 1.772 * u;
	
	gl_FragColor = vec4(r * v_color.r, g * v_color.g, b * v_color.b, v_color.a);
}
